#picaxe 20x2
let dirsB = %10111000	
let dirsC = %10011111	
symbol 	Amp_Flag = b2	
symbol 	Err_Code = b3
symbol 	LED_count = b5
symbol	TMR3 = w3
symbol	TMR3_prev = w4
symbol	TMR3_diff = w5
symbol	Vib_state = w0
symbol	Vib1_CPS = b4
symbol	Vib11_TL = w6
symbol 	Vib12_TL = w7
symbol	Vib13_TL = w8
symbol	Vib2_CPS = b18
symbol	Vib21_TL = w10
symbol 	Vib22_TL = w11
symbol	Vib23_TL = w12
symbol	Vib3_CPS = b19
symbol	Vib31_TL = w13
symbol 	Vib32_TL = w14
symbol	Vib33_TL = w15
symbol	Amp_Tot = w16
symbol	Vib12_ST = b34
symbol	Vib13_ST = b35
symbol	Vib22_ST = b36
symbol	Vib23_ST = b37
symbol	Vib32_ST = b38
symbol	Vib33_ST = b39
symbol	Vib12_PD = w20
symbol	Vib13_PD = w21
symbol	Vib22_PD = w22
symbol	Vib23_PD = w23
symbol	Vib32_PD = w24
symbol	Vib33_PD = w25
symbol	New_Data = b52
symbol	New_Data_prev = b53
symbol	Err_Counter = b54
symbol	Err_Enable = b55
setfreq m64			
Low B.3
hi2csetup i2cslave, $C2
HPWM PWMDIV4, 0, 0, %0011, 249, 0		
HPWMDUTY 500	
Pause 16000
High B.3
Vib_state = 0	
tmr3setup %10110001 
TMR3_prev = 0
bptr = 100 
let adcsetup = %0000100000010000
MainLoop:
Low A.0
peeksfr $B2, b6, b7
if TMR3 < TMR3_prev then			
TMR3_diff = 65535 - TMR3_prev + TMR3
else
TMR3_diff = TMR3 - TMR3_prev
end if
TMR3_diff = TMR3_diff / 200
TMR3_prev = TMR3
get 10, New_Data  
if New_Data != New_Data_prev then
get 11, Vib1_CPS, Vib2_CPS, Vib3_CPS, Vib12_ST, Vib13_ST, Vib22_ST, Vib23_ST, Vib32_ST, Vib33_ST, Amp_Flag
get 5, Err_Enable
Vib12_PD = Vib12_ST * 50 / Vib1_CPS		
Vib13_PD = Vib13_ST * 50 / Vib1_CPS
Vib22_PD = Vib22_ST * 50 / Vib2_CPS
Vib23_PD = Vib23_ST * 50 / Vib2_CPS
Vib32_PD = Vib32_ST * 50 / Vib3_CPS
Vib33_PD = Vib33_ST * 50 / Vib3_CPS
if bit16 = 0 then
Vib11_TL = 0
Vib12_TL = 0
Vib13_TL = 0
bit0 = 0
bit1 = 0
bit2 = 0
High A.0
end if
if bit17 = 0 then
Vib21_TL = 0
Vib22_TL = 0
Vib23_TL = 0
bit3 = 0
bit4 = 0
bit5 = 0
High A.0
end if
if bit18 = 0 then
Vib31_TL = 0
Vib32_TL = 0
Vib33_TL = 0
bit6 = 0
bit7 = 0
bit8 = 0
High A.0
end if
ptr = 6 
readadc B.2, @ptrinc 
readadc B.6, @ptr    
end if
New_Data_prev = New_Data
bptr = 100
get 21, b32, b33, @bptr
b52 = b32 + b33
if @bptr = b52 then	
if Amp_Tot = 0 then 
Amp_tot = 500
High A.0
end if
HPWMDUTY Amp_Tot	
end if
if Amp_tot != 0 then 
if Vib11_TL < TMR3_diff then
Togglebit Vib_state, 0		
Vib11_TL = 5000 / Vib1_CPS + Vib11_TL - TMR3_diff			
else
Vib11_TL = Vib11_TL - TMR3_diff	
end if
if Vib12_PD < TMR3_diff then
Togglebit Vib_state, 1		
else if Vib12_TL < TMR3_diff then
Togglebit Vib_state, 1
Vib12_TL = Vib12_PD + Vib12_TL - TMR3_diff	
else
Vib12_TL = Vib12_TL - TMR3_diff
end if
if Vib13_PD < TMR3_diff then
Togglebit Vib_state, 2		
else if Vib13_TL < TMR3_diff then
Togglebit Vib_state, 2
Vib13_TL = Vib13_PD + Vib13_TL - TMR3_diff
else
Vib13_TL = Vib13_TL - TMR3_diff
end if
if Vib21_TL < TMR3_diff then
Togglebit Vib_state, 3
Vib21_TL = 5000 / Vib2_CPS + Vib21_TL - TMR3_diff
else
Vib21_TL = Vib21_TL - TMR3_diff
end if
if Vib22_PD < TMR3_diff then
Togglebit Vib_state, 4		
else if Vib22_TL < TMR3_diff then
Togglebit Vib_state, 4
Vib22_TL = Vib22_PD + Vib22_TL - TMR3_diff
else
Vib22_TL = Vib22_TL - TMR3_diff
end if
if Vib23_PD < TMR3_diff then
Togglebit Vib_state, 5		
else if Vib23_TL < TMR3_diff then
Togglebit Vib_state, 5
Vib23_TL = Vib23_PD + Vib23_TL - TMR3_diff
else
Vib23_TL = Vib23_TL - TMR3_diff
end if
if Vib31_TL < TMR3_diff then
Togglebit Vib_state, 6
Vib31_TL = 5000 / Vib3_CPS + Vib31_TL - TMR3_diff
else
Vib31_TL = Vib31_TL - TMR3_diff
end if
if Vib32_PD < TMR3_diff then
Togglebit Vib_state, 7		
else if Vib32_TL < TMR3_diff then
Togglebit Vib_state, 7
Vib32_TL = Vib32_PD + Vib32_TL - TMR3_diff
else
Vib32_TL = Vib32_TL - TMR3_diff
end if
if Vib32_PD < TMR3_diff then
Togglebit Vib_state, 8		
else if Vib33_TL < TMR3_diff then
Togglebit Vib_state, 8
Vib33_TL = Vib33_PD + Vib33_TL - TMR3_diff
else
Vib33_TL = Vib33_TL - TMR3_diff
end if
put 2, b0, b1  
end if
if PinB.0 = 0 then  
High A.0  
end if
inc LED_count
if LED_count = 100 then
High A.0  
Err_Code = 0
bit24 = NOT PinB.0
bit25 = NOT PinB.1
readadc B.2, b52		
if b52 < 46 then		
bit26 = 1
end if
bit27 = 0		
put 4, Err_Code	
if Err_Code > 1 then goto FF_Flash  
LED_count = 0
end if
Goto MainLoop
FF_Flash:
HPWMDUTY 500	
toggle A.0
put 4, Err_Code	
pause 2000
goto FF_Flash
